#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.HTMLUI;

namespace Syncfusion.Windows.Forms.HTMLUI.Samples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private string customControlTemplateString;
		private string controlsString;
		private Syncfusion.Windows.Forms.HTMLUI.HTMLUIControl htmluiControl1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.RichTextBox richTextBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.customControlTemplateString = "<custom assembly='$$assembly$$' class='$$classname$$'  width='280'/><br/>";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.htmluiControl1 = new Syncfusion.Windows.Forms.HTMLUI.HTMLUIControl();
			this.panel1 = new System.Windows.Forms.Panel();
			this.richTextBox1 = new System.Windows.Forms.RichTextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button2 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.listView1 = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			((System.ComponentModel.ISupportInitialize)(this.htmluiControl1)).BeginInit();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// htmluiControl1
			// 
			this.htmluiControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.htmluiControl1.AutoScroll = true;
			this.htmluiControl1.AutoScrollMinSize = new System.Drawing.Size(318, 288);
			this.htmluiControl1.EnableMultithreading = false;
			this.htmluiControl1.IsOriginalTextCached = true;
			this.htmluiControl1.Name = "htmluiControl1";
			this.htmluiControl1.ShowTitle = false;
			this.htmluiControl1.Size = new System.Drawing.Size(328, 288);
			this.htmluiControl1.StartupDocument = "";
			this.htmluiControl1.StartupFolder = "";
			this.htmluiControl1.TabIndex = 4;
			this.htmluiControl1.Text = "<html xvisible=\"True\" xsize=\"{Width=0, Height=0}\" xlocation=\"{X=0,Y=0}\"><head xvi" +
				"sible=\"False\" xsize=\"{Width=0, Height=0}\" xlocation=\"{X=0,Y=0}\" /><body xvisible" +
				"=\"True\" xsize=\"{Width=71, Height=15}\" xlocation=\"{X=10,Y=0}\">htmluiControl1</bod" +
				"y></html>";
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.label2,
																				 this.label1,
																				 this.textBox1,
																				 this.button2,
																				 this.button1,
																				 this.textBox2,
																				 this.listView1});
			this.panel1.Location = new System.Drawing.Point(328, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(224, 296);
			this.panel1.TabIndex = 3;
			// 
			// richTextBox1
			// 
			this.richTextBox1.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.richTextBox1.Location = new System.Drawing.Point(0, 296);
			this.richTextBox1.Name = "richTextBox1";
			this.richTextBox1.Size = new System.Drawing.Size(558, 80);
			this.richTextBox1.TabIndex = 7;
			this.richTextBox1.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(15, 207);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 24);
			this.label2.TabIndex = 21;
			this.label2.Text = "Assembly Name";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(15, 151);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(84, 24);
			this.label1.TabIndex = 20;
			this.label1.Text = "Class Name";
			// 
			// textBox1
			// 
			this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textBox1.Location = new System.Drawing.Point(15, 175);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(190, 20);
			this.textBox1.TabIndex = 19;
			this.textBox1.Text = "Button";
			// 
			// button2
			// 
			this.button2.Enabled = false;
			this.button2.Location = new System.Drawing.Point(119, 143);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(96, 24);
			this.button2.TabIndex = 18;
			this.button2.Text = "Delete";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(111, 263);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(104, 24);
			this.button1.TabIndex = 17;
			this.button1.Text = "Add";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// textBox2
			// 
			this.textBox2.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textBox2.Location = new System.Drawing.Point(15, 231);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(198, 20);
			this.textBox2.TabIndex = 16;
			this.textBox2.Text = "System.Windows.Forms";
			// 
			// listView1
			// 
			this.listView1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.columnHeader1,
																						this.columnHeader2});
			this.listView1.FullRowSelect = true;
			this.listView1.Location = new System.Drawing.Point(7, 7);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(198, 128);
			this.listView1.TabIndex = 15;
			this.listView1.View = System.Windows.Forms.View.Details;
			this.listView1.SelectedIndexChanged += new System.EventHandler(this.listView1_SelectedIndexChanged);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Class Name";
			this.columnHeader1.Width = 86;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Assembly";
			this.columnHeader2.Width = 188;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.richTextBox1,
																		  this.htmluiControl1,
																		  this.panel1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "HTMLUI Create Controls";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.htmluiControl1)).EndInit();
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void FillInitialHTML()
		{
			CreateControl("Button", "System.Windows.Forms");
			CreateControl("Syncfusion.Windows.Forms.ButtonAdv", "Syncfusion.Shared.Base");
			CreateControl("Syncfusion.Windows.Forms.Tools.CurrencyTextBox", "Syncfusion.Shared.Base");
			CreateControl("DateTimePicker", "System.Windows.Forms");
			CreateControl("DataGrid", "System.Windows.Forms");

			AddToListView("Button", "System.Windows.Forms");
			AddToListView("Syncfusion.Windows.Forms.ButtonAdv", "Syncfusion.Shared.Base");
			AddToListView("Syncfusion.Windows.Forms.Tools.CurrencyTextBox", "Syncfusion.Shared.Base");
			AddToListView("DateTimePicker", "System.Windows.Forms");
			AddToListView("DataGrid", "System.Windows.Forms");

			SyncHTML();
		}

		private void SyncHTML()
		{
			string htmlStr = "<html><body>" + this.controlsString + "</body></html>";
			this.htmluiControl1.LoadFromString(htmlStr);
			this.richTextBox1.Text = htmlStr.Replace("<br/>", "<br/>\r\n");
		}


		private void Form1_Load(object sender, System.EventArgs e)
		{
			FillInitialHTML();
		}

		private void CreateControl(string className, string assemblyName)
		{
			string customHTML = this.customControlTemplateString.Replace("$$classname$$", className);
			customHTML = customHTML.Replace("$$assembly$$", assemblyName);
			this.controlsString += customHTML;
		}

		private void CreateAllControls()
		{
			this.controlsString = "";

			for(int i=0;i< this.listView1.Items.Count ;i++) 
			{ 
				CreateControl(this.listView1.Items[i].SubItems[0].Text, this.listView1.Items[i].SubItems[1].Text); 
			} 

			SyncHTML();
		}

		private void AddToListView(string className, string assemblyName)
		{
			ListViewItem item = this.listView1.Items.Add(className);
			item.SubItems.Add(assemblyName);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			AddToListView(this.textBox1.Text , this.textBox2.Text);
			CreateAllControls();
		}

		private void listView1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(this.listView1.SelectedItems.Count > 0)
				this.button2.Enabled = true;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			if(this.listView1.SelectedItems.Count > 0)
			{
				this.listView1.Items.Remove(this.listView1.SelectedItems[0]);
			}
			CreateAllControls();

			if(this.listView1.Items.Count > 0)
			{
				this.listView1.Items[0].Selected = true;
			}
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(this.controlsString);
		}
	}
}
